package find;

import java.io.File;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;

/**
 * Created on 23.12.2008, 16:43:04
 * @author Veikko Niemi
 */
public class FindText {

    private String text;
    private File in;
    private int foundCount; // count of found stringlines
    private int findIn;     // count of files text found
    private static boolean continueIgnoreCase = false;
    private static boolean firstTime = true;
    private String findSLower;
    private boolean foundF;     // string found first time in this file
    private String fileTxt;     // first time this file empty
    private boolean print;
    private JTextArea tarea;
    private String ls = System.getProperty("line.separator");
    private final int MAXLINELENGTH = 160;

    public FindText() {
    }

    public FindText(File in, String text, boolean print, JTextArea tarea) {
        this.text = text;
        this.in = in;
        this.foundCount = 0;
        this.findSLower = text.toLowerCase();
        this.foundF = true;
        this.fileTxt = "";
        this.print = print;
        this.tarea = tarea;
    }

    public int getFoundCount() {
        return this.foundCount;
    }

    public void setFindIn(int findIn) {
        if (findIn > -1) {
            this.findIn = findIn;
        }
    }

    public void setFirstTime(boolean first) {
        firstTime = first;
    }

    public boolean findText() {

        ReadFile lT = new ReadFile(in);
        String line;
        int lineCount = 0;
        do {
            line = lT.readNext();
            if (line != null) {
                lineCount++;
                searchLine(in, line, lineCount);
            }
        } while (line != null);
        if (foundCount > 0) {
            return true;
        }
        return false;
    }

    private void searchLine(File in, String line, int lineCount) {
        if (!line.isEmpty()) {
            if (line.indexOf(text) >= 0) {
                foundCount++;
                if (foundF) {
                    foundF = false;
                    findIn++; // count of files found string
                    fileTxt = "Found in " + findIn + ". file " + in.toString() + ls;
                }
                tarea.append(fileTxt);
                if (print) {
                    tarea.append("Found line " + lineCount + ". " + line + ls);
                }
                fileTxt = "";
            } else {
                if (continueIgnoreCase || firstTime) {
                    if (line.toLowerCase().indexOf(findSLower) >= 0) {
                        if (firstTime) {
                            foundIgnoreCase(line);
                        }
                        if (continueIgnoreCase) {
                            if (foundF) {
                                foundF = false;
                                findIn++;
                                fileTxt = "Found in file " + findIn + ". " + in.toString() + ls;
                            }
                            foundCount++;
                            tarea.append(fileTxt);
                            if (print) {
                                tarea.append("Found line " + lineCount + ". " + line + ls);
                            }
                            fileTxt = "";
                        }
                    }
                }

            }
        }
    }

    private void foundIgnoreCase(String line) {
        firstTime = false;
        String l = splitIn(line);
        int response = JOptionPane.showConfirmDialog(
                null,
                "Found line with ignore case, do I continue with ignore case\n" + l,
                "case or ignore case",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE);
        if (response == JOptionPane.YES_OPTION) {
            continueIgnoreCase = true;
        }
    }

    private String splitIn(String line){
        String palauta = "";
        for (int i = 0; i < line.length(); i += MAXLINELENGTH){
            if (i + MAXLINELENGTH < line.length())palauta += line.substring(i, i + MAXLINELENGTH) + ls;
            else palauta += line.substring(i) + ls;
        }
        return palauta;
    }

    private void error(String show) {
        JOptionPane.showMessageDialog(null, show, "error",
                JOptionPane.ERROR_MESSAGE);
    }

    private void attention(String show) {
        JOptionPane.showMessageDialog(null, show, "attention",
                JOptionPane.INFORMATION_MESSAGE);
    }
}
