/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package find;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Calendar;
import javax.swing.JOptionPane;
import javax.swing.Timer;

/**
 * Created on 29.12.2008, 9:26:23
 * @author Veikko Niemi
 */
public class StartFind {

    private File[] highFiles;
    private String[] fileFilters;
    private static LogPanel logPanel;
    private String lS = System.getProperty("line.separator");
    private static boolean once = true;
    private Timer swTimer;
    private static long  start = Calendar.getInstance().getTimeInMillis();

    public StartFind() {
        WalkFiles.estimatedTime = -1.0;
        if (once) {

            // This action listener is called when the timer
            // goes off.
            ActionListener timerAL = new ActionListener() {

                public void actionPerformed(ActionEvent ae) {
                    updateTime();
                }
            };

            // Create a timer that goes off every tenth of a second.
            swTimer = new Timer(100, timerAL);
            swTimer.start();
           
            logPanel = new LogPanel();
            once = false;
        }
        Container cTArea = logPanel.getContentPane();
        logPanel.setVisible(true);
        Browse br = new Browse();
        highFiles = br.getInputs();
        run();
    }

    protected static void updateTime() {
        DecimalFormat df = new DecimalFormat("####0.00 sec");
        String text = "";
        if (WalkFiles.estimatedTime > -1) {
            text = "<br/>Estimated time: " + df.format(WalkFiles.estimatedTime);
        }
        long stop = Calendar.getInstance().getTimeInMillis();
        Double t = (stop - start) / 1000.;
        Find.estimatedTime.setText("<html>" + df.format(t) + text);
    }

    private boolean checkTfStart() {
        String help = Find.tfStart.getText().trim();
        if (!help.isEmpty()) {
            File hlp = new File(help);
            if (hlp.isDirectory() || hlp.isFile()) {
                highFiles = new File[1];
                highFiles[0] = hlp;
                return true;
            }
            LogPanel.jTextArea1.append("Is not a file or folder: " + help + lS);
            error("Is not a file or folder: " + help);
            Find.tfStart.setText("");
            Find.tfStart.requestFocus();
            return false;
        }
        return true;
    }

    private void setFilters() {
        String help = Find.tfFileTypes.getText().trim();
        if (help.isEmpty()) {
            fileFilters = new String[0];
        } else {
            fileFilters = help.split("[, ]");
        }
        if (fileFilters.length > 0) {
            LogPanel.jTextArea1.append("Using following file filters:" + lS);
        } else {
            LogPanel.jTextArea1.append("All files search, no filters selected" + lS);
        }
        for (int i = 0; i < fileFilters.length; i++) {
            LogPanel.jTextArea1.append(fileFilters[i] + lS);
        }
    }

    private void run() {

        Calendar cal = Calendar.getInstance();
        long startTime = cal.getTimeInMillis();
        int foundInFiles = 0;
        setFilters();
        ArrayList<File> files;	//only real Files
        String findS = Find.tfSearch.getText();
        int foundCount = 0;
        boolean print;
        if (Find.cbVerify.isSelected()) {
            print = true;
        } else {
            print = false;
        }
        if (findS.isEmpty()) {
            LogPanel.jTextArea1.append("FIND text: - field is empty - can't start" + lS);
            error("FIND text: - field is empty - can't start");
            Find.tfSearch.requestFocus();
        } else {
            if (checkTfStart() && highFiles != null && highFiles.length > 0) {

                LogPanel.jTextArea1.append("Searching string \"" + findS + "\"" + lS);
                WalkFiles wf = new WalkFiles(highFiles, fileFilters, LogPanel.jTextArea1);
                files = wf.getFiles();
                FindText ft = new FindText();
                for (int i = 0; i < files.size(); i++) {
                    if (print) {
                        LogPanel.jTextArea1.append((i + 1) + ". " + files.get(i) + lS);
                    }
                    ft = new FindText(files.get(i), findS, print, LogPanel.jTextArea1);
                    ft.setFindIn(foundInFiles);
                    if (ft.findText()) {
                        foundInFiles++;
                    }
                    foundCount += ft.getFoundCount();
                }
                ft.setFirstTime(true);
                LogPanel.jTextArea1.append("*************************************************************************************" + lS);
                LogPanel.jTextArea1.append("Searching string " + "\"" + findS + "\"" + " done in catalogs/files:" + lS);
                for (int i = 0; i < highFiles.length; i++) {
                    LogPanel.jTextArea1.append(highFiles[i] + lS);
                }
                String lockText = "";
                if (wf.getLockFilesCount() > 0) {
                    lockText = lS + "Total count of skipped locked files " + wf.getLockFilesCount();
                }
                 String encoding = (String) Find.jComboBox1.getSelectedItem();
                LogPanel.jTextArea1.append("Total foldercount " + wf.getFoldersCount() +
                        lS + "Total filecount " + wf.getTotalFilesCount() +
                        lS + "Selected filecount " + files.size() + lockText +
                        lS + "Total count of found stringlines " + foundCount + " in " + foundInFiles + " files" +
                        lS + "File encoding: " + encoding + lS);
                foundCount = 0;
                foundInFiles = 0;
                highFiles = new File[0];
//                Find.tfStart.setText("");
//                Find.tfFileTypes.setText("");
//                Find.tfSearch.setText("");
                Find.tfStart.requestFocus();
            } else {
                attention("either browse or fill starting catalog");
                Find.tfStart.requestFocus();
            }
        }
        Calendar cal2 = Calendar.getInstance();
        long endTime = cal2.getTimeInMillis();
        Double elapsedTime = (endTime - startTime) / 1000.;
        DecimalFormat df = new DecimalFormat("##0.0");
        LogPanel.jTextArea1.append("Elapsed time " + df.format(elapsedTime) + "s" + lS);
        LogPanel.jTextArea1.append("*************************************************************************************" + lS);
    }

    private void error(String show) {
        JOptionPane.showMessageDialog(null, show, "error",
                JOptionPane.ERROR_MESSAGE);
    }

    private void attention(String show) {
        JOptionPane.showMessageDialog(null, show, "attention",
                JOptionPane.INFORMATION_MESSAGE);
    }

    public static void main(String[] args) {
        Find f = new Find();
        f.setVisible(true);
    }
}
